/*
 * main.c
 * gibt CW-Zeichen akustisch ber einen Beeper aus
 * luft interrupt-gesteuert im Hintergund
 * created 29.12.2015 DL9MWE
 * 07.01.2016
 *
 */
#include "main.h"


void main(void) {
	vCPU_init();
	vTimerA0_init();
	vMorseBeeper_init();
	_bis_SR_register(GIE);	//erlaube Interrupts

//	_delay_ms(10000);		// Test der delay-Funktion: soll 10 Sekunden sein

	while(42) {
		vMorseBeeper(2*8, 0x0000c591L, 5*MS_KURZ);	// CQ
		vMorseBeeper(2*4, 0x000000a1L, 5*MS_KURZ);	// DE
		vMorseBeeper(2*14, 0x0d956121L, 0*MS_KURZ);	// DL9M
		vMorseBeeper(2*4, 0x000000b4L, 5*MS_KURZ);	// WE
		vMorseBeeper(2*8, 0x0000a094L, 5*MS_KURZ);	// PSE
		vMorseBeeper(2*3, 0x00000031L, 5*MS_KURZ);	// K
	}
}

void vCPU_init(void) {
	WDTCTL = WDTPW + WDTHOLD;				// Disable Watchdog
//initialize Basic Clock Module using DCO
#if F_MHZ == 8
#endif
#if F_MHZ == 12
#endif
#if F_MHZ == 16
	DCOCTL = CALDCO_16MHZ;
	BCSCTL1 = DIVA_0 + CALBC1_16MHZ;		// ACLK-Divider = 1
#endif
	BCSCTL2 = SELM_0 | DIVM_0 | DIVS_0;		// MCLK und SMCLK sind DCOCLK, Divider=1
}

// msec Millisekunden im Low Power Modus warten. Jede 1ms wird ein Interrupt durch den Timer ausgelst.
void _delay_ms(unsigned int msec) {
	if(timertick_ms = msec)			// darf auch 0 sein...
		_BIS_SR(LPM0_bits + GIE);	// Enter LPM0
#if 0
  volatile unsigned int count;
	while(msec--) {
#if (F_MHZ == 8)
		count = 624;	// passt bei 8MHz aus dem internen Oszillator DCO
#endif
#if (F_MHZ == 12)
		count = 1200;	// passt bei 12MHz aus dem internen Oszillator DCO
#endif
#if (F_MHZ == 16)
		count = 1600;	// passt bei 16MHz aus dem internen Oszillator DCO
#endif
		while(count) {
			--count;
		}
	}
#endif
}

// Ende main.c
